# File

## *class* <mark style="color:purple;">File</mark>

An interface for working with raw files stored on Redivis.

{% hint style="info" %}
Redivis automatically registers itself with [fsspec](https://filesystem-spec.readthedocs.io/en/latest/) on import. If you are working with an fsspec compatible library, you can use the Redivis file URI scheme to reference files directly:

```python
with fsspec.open("redivis://table_reference/path/to/file") as f:
    """ Do great things """
```

{% endhint %}

## Constructors

<table data-header-hidden><thead><tr><th width="368">Method</th><th>Description</th></tr></thead><tbody><tr><td><a href="/pages/o3Fpd3IKJyYLG0p4xuKN"><strong><code>Table.file</code></strong></a>(path)</td><td>Reference a file within a table.</td></tr><tr><td><a href="/pages/7rETab3N7Jli2URaSJ9V"><strong><code>Query.file</code></strong></a>(path)</td><td>Reference a file within a query result</td></tr><tr><td><a href="/pages/ko984apgZa0RNDgYCAAL"><strong><code>Directory.get</code></strong></a>(path)</td><td>Get a file (or directory) within a directory.</td></tr><tr><td><a href="/pages/M71WneRMzhKsiHOgQPjN"><strong><code>Directory.list</code></strong></a>([max_results, *, ...])</td><td>List files (and/or directories) within a directory</td></tr><tr><td><a href="/pages/w2FfkwPQSE9WpfaspqiQ"><strong><code>Query.list_files</code></strong></a>([max_results, *, ...])</td><td>List files contained within a query result. The query result must contain at least one file_id variable.</td></tr><tr><td><a href="/pages/xNaU9ux3jrmfKFQ4kNUR"><strong><code>Table.list_files</code></strong></a>([max_results, *, ...])</td><td>List files contained within a file index table. The table must contain at least one file_id variable.</td></tr></tbody></table>

## Examples

```python
import redivis
from io import TextIOWrapper
from PIL import Image

# See https://redivis.com/datasets/yz1s-d09009dbb/files for example data
table = redivis.table("demo.example_data_files:yz1s:v1_3.example_file_types:4c10")
text_file = table.file("pandas_core.py")
image_file = table.file("bogota.tiff")

## Read file contents
str = text_file.read(as_text=True)
bytes = image_file.read()

## Open the file, as if it was on the filesystem
with file.open("rb") as f:
  f.read(100) # read 100 bytes

with file.open() as f:
  f.readline() # read first line
  
# Tools that integrate with fsspec can open Redivis URIs:
pystac.Catalog.from_file("redivis://table_ref/stac/catalog.json")
  
Image.open(table.file("bogota.tiff")) # PIL will automatically call open() on the file
  
## Download the file  
image_file.download("./path") # will be downloaded as ./path/bogota.tiff
text_file.download("./path/renamed.txt") # will be downloaded as ./path/renamed.txt
```

## Attributes

| **`directory`**  | A reference to the associated [Directory](/api/client-libraries/redivis-python/reference/directory.md) for this file.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| ---------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **`id`**         | The globally unique identifier for the file, as a string.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |
| **`name`**       | The name of the file as a string, without any directory subpaths as present. Same as `file.path.name`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| **`path`**       | The full path of the file, as a pathlib.Path                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        |
| **`query`**      | A reference to the [Query](/api/client-libraries/redivis-python/reference/query.md) from which this file was loaded from. Either this or `table` will be present.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| **`properties`** | <p>A dict containing properties associated with the file. This will always contain the following properties, derived from the file's original index table:<br></p><ul><li><strong><code>file\_id</code></strong> (str): The globally unique id of the file</li><li><strong><code>file\_name</code></strong> (str): The full name of the file, including any extensions</li><li><strong><code>size</code></strong> (int): The size of the file, in bytes</li><li><strong><code>added\_at</code></strong> (datetime): When the file was initially uploaded to Redivis</li><li><strong><code>md5\_hash</code></strong> (str): The md5 checksum of the file, as a base64 string</li></ul><p>Additionally, if the file was loaded from a table or query with additional variables, those variables' values will exist in properties.</p> |
| **`table`**      | A reference to the [Table](/api/client-libraries/redivis-python/reference/table.md) from which this file was loaded from.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           |

## Methods

<table data-header-hidden><thead><tr><th width="421">Name</th><th>Description</th></tr></thead><tbody><tr><td><a href="/pages/rgueEp830XcHAc3xGArR"><strong><code>file.download</code></strong></a>(path[, ...])</td><td>Download the file.</td></tr><tr><td><a href="/pages/qrApJYbHRTeaNcWTcnMD"><strong><code>file.read</code></strong></a>(*[, as_text, start_byte, end_byte])</td><td>Read the file contents into memory, either as bytes (the default) or as a string if as_text=True.</td></tr><tr><td><a href="/pages/XbrkKj53ViitbZqA6BuW"><strong><code>file.open</code></strong></a>(*, [start_byte, end_byte])</td><td>Read the file as a BytesIO stream, as if it was located on disk.</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.redivis.com/api/client-libraries/redivis-python/reference/file.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
